> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://virtuous.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://virtuous.ferndocs.com/_mcp/server.

# Query Projects

POST https://api.virtuoussoftware.com/api/Project/Query
Content-Type: application/json

To see which options can be sent, use the \{M:Virtuous.WebApi.Controllers.ProjectController.QueryOptions} endpoint.
If you're going to consistently query for updated projects or new projects, don't. Use a webhook instead.
If requests are timing out, you may be asking for too many items at once. The max take is 1,000.

Reference: https://virtuous.ferndocs.com/reference/crm-plus/projects/query-projects

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Servers

- `https://api.virtuoussoftware.com` (https://api.virtuoussoftware.com, default)
- `{{baseUrl}}api` ({{baseUrl}}api)

## Request

### Query parameters

- `skip` (integer, optional) — The number of records to skip. Default = 0.
- `take` (integer, optional) — The number of records to take. Default = 10. Max is 1000.

### Body (application/json)

This endpoint expects an object.

- `groups` (list of ApiProjectQueryPostRequestBodyContentApplicationJsonSchemaGroupsItems, optional)
- `sortBy` (string, optional)
- `descending` (string, optional)

## Response

### 200

OK

- `list` (list of ApiProjectQueryPostResponsesContentApplicationJsonSchemaListItems, optional)
- `total` (string, optional)

## Errors

### 400 Bad Request Error

BadRequest

- `any`

## Types

### ApiProjectQueryPostRequestBodyContentApplicationJsonSchemaGroupsItems

- `conditions` (list of ApiProjectQueryPostRequestBodyContentApplicationJsonSchemaGroupsItemsConditionsItems, optional)

### ApiProjectQueryPostResponsesContentApplicationJsonSchemaListItems

- `id` (string, optional)
- `name` (string, optional)
- `projectCode` (string, optional)
- `externalAccountingCode` (string, optional)
- `onlineDisplayName` (string, optional)
- `description` (string, optional)
- `photoUrl` (string, optional)
- `parentId` (string, optional)
- `parentName` (string, optional)
- `isSubProject` (string, optional)
- `inventoryStatus` (string, optional)
- `type` (string, optional)
- `location` (string, optional)
- `isRestrictedToGiftSpecifications` (string, optional)
- `isLimitedToFinancialNeed` (string, optional)
- `isPublic` (string, optional)
- `isActive` (string, optional)
- `isAvailableOnline` (string, optional)
- `isTaxDeductible` (string, optional)
- `treatAsAccountsPayable` (string, optional)
- `beginningBalance` (string, optional)
- `currentBalance` (string, optional)
- `financialNeedType` (string, optional)
- `financialNeedFrequency` (string, optional)
- `financialNeedAmount` (string, optional)
- `startDate` (string, optional)
- `endDate` (string, optional)
- `durationType` (string, optional)
- `lifeToDateGiving` (string, optional)
- `lifeToDateGiftCount` (string, optional)
- `lifeToDateGiversCount` (string, optional)
- `lifeToDateExpenseTotal` (string, optional)
- `calendarYearToDateGiving` (string, optional)
- `calendarYearToDateGiftCount` (string, optional)
- `calendarYearToDateGiversCount` (string, optional)
- `calendarYearToDateExpenseTotal` (string, optional)
- `createDateTimeUtc` (string, optional)
- `createdByUser` (string, optional)
- `modifiedDateTimeUtc` (string, optional)
- `modifiedByUser` (string, optional)
- `giftSpecifications` (list of ApiProjectQueryPostResponsesContentApplicationJsonSchemaListItemsGiftSpecificationsItems, optional)
- `customFields` (string, optional)

### ApiProjectQueryPostRequestBodyContentApplicationJsonSchemaGroupsItemsConditionsItems

- `parameter` (string, optional)
- `operator` (string, optional)
- `value` (string, optional)
- `secondaryValue` (string, optional)
- `values` (list of string, optional)

### ApiProjectQueryPostResponsesContentApplicationJsonSchemaListItemsGiftSpecificationsItems

- `amount` (string, optional)
- `frequency` (string, optional)

## Examples

**Request**

```json
{
  "groups": [
    {
      "conditions": [
        {
          "parameter": "<string>",
          "operator": "<string>",
          "value": "<string>",
          "secondaryValue": "<string>",
          "values": [
            "<string>",
            "<string>"
          ]
        },
        {
          "parameter": "<string>",
          "operator": "<string>",
          "value": "<string>",
          "secondaryValue": "<string>",
          "values": [
            "<string>",
            "<string>"
          ]
        }
      ]
    },
    {
      "conditions": [
        {
          "parameter": "<string>",
          "operator": "<string>",
          "value": "<string>",
          "secondaryValue": "<string>",
          "values": [
            "<string>",
            "<string>"
          ]
        },
        {
          "parameter": "<string>",
          "operator": "<string>",
          "value": "<string>",
          "secondaryValue": "<string>",
          "values": [
            "<string>",
            "<string>"
          ]
        }
      ]
    }
  ],
  "sortBy": "<string>",
  "descending": "<boolean>"
}
```

**Response**

```json
{
  "list": [
    {
      "id": "<integer>",
      "name": "<string>",
      "projectCode": "<string>",
      "externalAccountingCode": "<string>",
      "onlineDisplayName": "<string>",
      "description": "<string>",
      "photoUrl": "<string>",
      "parentId": "<integer>",
      "parentName": "<string>",
      "isSubProject": "<boolean>",
      "inventoryStatus": "<string>",
      "type": "<string>",
      "location": "<string>",
      "isRestrictedToGiftSpecifications": "<boolean>",
      "isLimitedToFinancialNeed": "<boolean>",
      "isPublic": "<boolean>",
      "isActive": "<boolean>",
      "isAvailableOnline": "<boolean>",
      "isTaxDeductible": "<boolean>",
      "treatAsAccountsPayable": "<boolean>",
      "beginningBalance": "<double>",
      "currentBalance": "<double>",
      "financialNeedType": "<string>",
      "financialNeedFrequency": "<string>",
      "financialNeedAmount": "<double>",
      "startDate": "<dateTime>",
      "endDate": "<dateTime>",
      "durationType": "<string>",
      "lifeToDateGiving": "<double>",
      "lifeToDateGiftCount": "<integer>",
      "lifeToDateGiversCount": "<integer>",
      "lifeToDateExpenseTotal": "<double>",
      "calendarYearToDateGiving": "<double>",
      "calendarYearToDateGiftCount": "<integer>",
      "calendarYearToDateGiversCount": "<integer>",
      "calendarYearToDateExpenseTotal": "<double>",
      "createDateTimeUtc": "<dateTime>",
      "createdByUser": "<string>",
      "modifiedDateTimeUtc": "<dateTime>",
      "modifiedByUser": "<string>",
      "giftSpecifications": [
        {
          "amount": "<double>",
          "frequency": "<string>"
        },
        {
          "amount": "<double>",
          "frequency": "<string>"
        }
      ],
      "customFields": "<object>"
    },
    {
      "id": "<integer>",
      "name": "<string>",
      "projectCode": "<string>",
      "externalAccountingCode": "<string>",
      "onlineDisplayName": "<string>",
      "description": "<string>",
      "photoUrl": "<string>",
      "parentId": "<integer>",
      "parentName": "<string>",
      "isSubProject": "<boolean>",
      "inventoryStatus": "<string>",
      "type": "<string>",
      "location": "<string>",
      "isRestrictedToGiftSpecifications": "<boolean>",
      "isLimitedToFinancialNeed": "<boolean>",
      "isPublic": "<boolean>",
      "isActive": "<boolean>",
      "isAvailableOnline": "<boolean>",
      "isTaxDeductible": "<boolean>",
      "treatAsAccountsPayable": "<boolean>",
      "beginningBalance": "<double>",
      "currentBalance": "<double>",
      "financialNeedType": "<string>",
      "financialNeedFrequency": "<string>",
      "financialNeedAmount": "<double>",
      "startDate": "<dateTime>",
      "endDate": "<dateTime>",
      "durationType": "<string>",
      "lifeToDateGiving": "<double>",
      "lifeToDateGiftCount": "<integer>",
      "lifeToDateGiversCount": "<integer>",
      "lifeToDateExpenseTotal": "<double>",
      "calendarYearToDateGiving": "<double>",
      "calendarYearToDateGiftCount": "<integer>",
      "calendarYearToDateGiversCount": "<integer>",
      "calendarYearToDateExpenseTotal": "<double>",
      "createDateTimeUtc": "<dateTime>",
      "createdByUser": "<string>",
      "modifiedDateTimeUtc": "<dateTime>",
      "modifiedByUser": "<string>",
      "giftSpecifications": [
        {
          "amount": "<double>",
          "frequency": "<string>"
        },
        {
          "amount": "<double>",
          "frequency": "<string>"
        }
      ],
      "customFields": "<object>"
    }
  ],
  "total": "<integer>"
}
```

**SDK Code**

```python Projects_queryProjects_example
import requests

url = "https://api.virtuoussoftware.com/api/Project/Query"

querystring = {"skip":"1","take":"1"}

payload = {
    "groups": [{ "conditions": [
                {
                    "parameter": "<string>",
                    "operator": "<string>",
                    "value": "<string>",
                    "secondaryValue": "<string>",
                    "values": ["<string>", "<string>"]
                },
                {
                    "parameter": "<string>",
                    "operator": "<string>",
                    "value": "<string>",
                    "secondaryValue": "<string>",
                    "values": ["<string>", "<string>"]
                }
            ] }, { "conditions": [
                {
                    "parameter": "<string>",
                    "operator": "<string>",
                    "value": "<string>",
                    "secondaryValue": "<string>",
                    "values": ["<string>", "<string>"]
                },
                {
                    "parameter": "<string>",
                    "operator": "<string>",
                    "value": "<string>",
                    "secondaryValue": "<string>",
                    "values": ["<string>", "<string>"]
                }
            ] }],
    "sortBy": "<string>",
    "descending": "<boolean>"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers, params=querystring)

print(response.json())
```

```javascript Projects_queryProjects_example
const url = 'https://api.virtuoussoftware.com/api/Project/Query?skip=1&take=1';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"groups":[{"conditions":[{"parameter":"<string>","operator":"<string>","value":"<string>","secondaryValue":"<string>","values":["<string>","<string>"]},{"parameter":"<string>","operator":"<string>","value":"<string>","secondaryValue":"<string>","values":["<string>","<string>"]}]},{"conditions":[{"parameter":"<string>","operator":"<string>","value":"<string>","secondaryValue":"<string>","values":["<string>","<string>"]},{"parameter":"<string>","operator":"<string>","value":"<string>","secondaryValue":"<string>","values":["<string>","<string>"]}]}],"sortBy":"<string>","descending":"<boolean>"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Projects_queryProjects_example
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.virtuoussoftware.com/api/Project/Query?skip=1&take=1"

	payload := strings.NewReader("{\n  \"groups\": [\n    {\n      \"conditions\": [\n        {\n          \"parameter\": \"<string>\",\n          \"operator\": \"<string>\",\n          \"value\": \"<string>\",\n          \"secondaryValue\": \"<string>\",\n          \"values\": [\n            \"<string>\",\n            \"<string>\"\n          ]\n        },\n        {\n          \"parameter\": \"<string>\",\n          \"operator\": \"<string>\",\n          \"value\": \"<string>\",\n          \"secondaryValue\": \"<string>\",\n          \"values\": [\n            \"<string>\",\n            \"<string>\"\n          ]\n        }\n      ]\n    },\n    {\n      \"conditions\": [\n        {\n          \"parameter\": \"<string>\",\n          \"operator\": \"<string>\",\n          \"value\": \"<string>\",\n          \"secondaryValue\": \"<string>\",\n          \"values\": [\n            \"<string>\",\n            \"<string>\"\n          ]\n        },\n        {\n          \"parameter\": \"<string>\",\n          \"operator\": \"<string>\",\n          \"value\": \"<string>\",\n          \"secondaryValue\": \"<string>\",\n          \"values\": [\n            \"<string>\",\n            \"<string>\"\n          ]\n        }\n      ]\n    }\n  ],\n  \"sortBy\": \"<string>\",\n  \"descending\": \"<boolean>\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Projects_queryProjects_example
require 'uri'
require 'net/http'

url = URI("https://api.virtuoussoftware.com/api/Project/Query?skip=1&take=1")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"groups\": [\n    {\n      \"conditions\": [\n        {\n          \"parameter\": \"<string>\",\n          \"operator\": \"<string>\",\n          \"value\": \"<string>\",\n          \"secondaryValue\": \"<string>\",\n          \"values\": [\n            \"<string>\",\n            \"<string>\"\n          ]\n        },\n        {\n          \"parameter\": \"<string>\",\n          \"operator\": \"<string>\",\n          \"value\": \"<string>\",\n          \"secondaryValue\": \"<string>\",\n          \"values\": [\n            \"<string>\",\n            \"<string>\"\n          ]\n        }\n      ]\n    },\n    {\n      \"conditions\": [\n        {\n          \"parameter\": \"<string>\",\n          \"operator\": \"<string>\",\n          \"value\": \"<string>\",\n          \"secondaryValue\": \"<string>\",\n          \"values\": [\n            \"<string>\",\n            \"<string>\"\n          ]\n        },\n        {\n          \"parameter\": \"<string>\",\n          \"operator\": \"<string>\",\n          \"value\": \"<string>\",\n          \"secondaryValue\": \"<string>\",\n          \"values\": [\n            \"<string>\",\n            \"<string>\"\n          ]\n        }\n      ]\n    }\n  ],\n  \"sortBy\": \"<string>\",\n  \"descending\": \"<boolean>\"\n}"

response = http.request(request)
puts response.read_body
```

```java Projects_queryProjects_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.virtuoussoftware.com/api/Project/Query?skip=1&take=1")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"groups\": [\n    {\n      \"conditions\": [\n        {\n          \"parameter\": \"<string>\",\n          \"operator\": \"<string>\",\n          \"value\": \"<string>\",\n          \"secondaryValue\": \"<string>\",\n          \"values\": [\n            \"<string>\",\n            \"<string>\"\n          ]\n        },\n        {\n          \"parameter\": \"<string>\",\n          \"operator\": \"<string>\",\n          \"value\": \"<string>\",\n          \"secondaryValue\": \"<string>\",\n          \"values\": [\n            \"<string>\",\n            \"<string>\"\n          ]\n        }\n      ]\n    },\n    {\n      \"conditions\": [\n        {\n          \"parameter\": \"<string>\",\n          \"operator\": \"<string>\",\n          \"value\": \"<string>\",\n          \"secondaryValue\": \"<string>\",\n          \"values\": [\n            \"<string>\",\n            \"<string>\"\n          ]\n        },\n        {\n          \"parameter\": \"<string>\",\n          \"operator\": \"<string>\",\n          \"value\": \"<string>\",\n          \"secondaryValue\": \"<string>\",\n          \"values\": [\n            \"<string>\",\n            \"<string>\"\n          ]\n        }\n      ]\n    }\n  ],\n  \"sortBy\": \"<string>\",\n  \"descending\": \"<boolean>\"\n}")
  .asString();
```

```php Projects_queryProjects_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.virtuoussoftware.com/api/Project/Query?skip=1&take=1', [
  'body' => '{
  "groups": [
    {
      "conditions": [
        {
          "parameter": "<string>",
          "operator": "<string>",
          "value": "<string>",
          "secondaryValue": "<string>",
          "values": [
            "<string>",
            "<string>"
          ]
        },
        {
          "parameter": "<string>",
          "operator": "<string>",
          "value": "<string>",
          "secondaryValue": "<string>",
          "values": [
            "<string>",
            "<string>"
          ]
        }
      ]
    },
    {
      "conditions": [
        {
          "parameter": "<string>",
          "operator": "<string>",
          "value": "<string>",
          "secondaryValue": "<string>",
          "values": [
            "<string>",
            "<string>"
          ]
        },
        {
          "parameter": "<string>",
          "operator": "<string>",
          "value": "<string>",
          "secondaryValue": "<string>",
          "values": [
            "<string>",
            "<string>"
          ]
        }
      ]
    }
  ],
  "sortBy": "<string>",
  "descending": "<boolean>"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Projects_queryProjects_example
using RestSharp;

var client = new RestClient("https://api.virtuoussoftware.com/api/Project/Query?skip=1&take=1");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"groups\": [\n    {\n      \"conditions\": [\n        {\n          \"parameter\": \"<string>\",\n          \"operator\": \"<string>\",\n          \"value\": \"<string>\",\n          \"secondaryValue\": \"<string>\",\n          \"values\": [\n            \"<string>\",\n            \"<string>\"\n          ]\n        },\n        {\n          \"parameter\": \"<string>\",\n          \"operator\": \"<string>\",\n          \"value\": \"<string>\",\n          \"secondaryValue\": \"<string>\",\n          \"values\": [\n            \"<string>\",\n            \"<string>\"\n          ]\n        }\n      ]\n    },\n    {\n      \"conditions\": [\n        {\n          \"parameter\": \"<string>\",\n          \"operator\": \"<string>\",\n          \"value\": \"<string>\",\n          \"secondaryValue\": \"<string>\",\n          \"values\": [\n            \"<string>\",\n            \"<string>\"\n          ]\n        },\n        {\n          \"parameter\": \"<string>\",\n          \"operator\": \"<string>\",\n          \"value\": \"<string>\",\n          \"secondaryValue\": \"<string>\",\n          \"values\": [\n            \"<string>\",\n            \"<string>\"\n          ]\n        }\n      ]\n    }\n  ],\n  \"sortBy\": \"<string>\",\n  \"descending\": \"<boolean>\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Projects_queryProjects_example
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "groups": [["conditions": [
        [
          "parameter": "<string>",
          "operator": "<string>",
          "value": "<string>",
          "secondaryValue": "<string>",
          "values": ["<string>", "<string>"]
        ],
        [
          "parameter": "<string>",
          "operator": "<string>",
          "value": "<string>",
          "secondaryValue": "<string>",
          "values": ["<string>", "<string>"]
        ]
      ]], ["conditions": [
        [
          "parameter": "<string>",
          "operator": "<string>",
          "value": "<string>",
          "secondaryValue": "<string>",
          "values": ["<string>", "<string>"]
        ],
        [
          "parameter": "<string>",
          "operator": "<string>",
          "value": "<string>",
          "secondaryValue": "<string>",
          "values": ["<string>", "<string>"]
        ]
      ]]],
  "sortBy": "<string>",
  "descending": "<boolean>"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.virtuoussoftware.com/api/Project/Query?skip=1&take=1")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```